libvisio::VSDGeometryList Class Reference documentation

libvisio::VSDGeometryList Class Reference

`#include <VSDGeometryList.h>`

## Public Member Functions
| VSDGeometryList ()
| VSDGeometryList (const VSDGeometryList &geomList)
| ~VSDGeometryList ()
VSDGeometryList & | operator= (const VSDGeometryList &geomList)
void | addGeometry (unsigned id, unsigned level, const boost::optional< bool > &noFill, const boost::optional< bool > &noLine, const boost::optional< bool > &noShow)
void | addEmpty (unsigned id, unsigned level)
void | addMoveTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y)
void | addLineTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y)
void | addArcTo (unsigned id, unsigned level, const boost::optional< double > &x2, const boost::optional< double > &y2, const boost::optional< double > &bow)
void | addNURBSTo (unsigned id, unsigned level, double x2, double y2, unsigned char xType, unsigned char yType, unsigned degree, const std::vector< std::pair< double, double > > &controlPoints, const std::vector< double > &knotVector, const std::vector< double > &weights)
void | addNURBSTo (unsigned id, unsigned level, double x2, double y2, double knot, double knotPrev, double weight, double weightPrev, unsigned dataID)
void | addNURBSTo (unsigned id, unsigned level, const boost::optional< double > &x2, const boost::optional< double > &y2, const boost::optional< double > &knot, const boost::optional< double > &knotPrev, const boost::optional< double > &weight, const boost::optional< double > &weightPrev, const boost::optional< NURBSData > &data)
void | addPolylineTo (unsigned id, unsigned level, double x, double y, unsigned char xType, unsigned char yType, const std::vector< std::pair< double, double > > &points)
void | addPolylineTo (unsigned id, unsigned level, double x, double y, unsigned dataID)
void | addPolylineTo (unsigned id, unsigned level, boost::optional< double > &x, boost::optional< double > &y, boost::optional< PolylineData > &data)
void | addEllipse (unsigned id, unsigned level, const boost::optional< double > &cx, const boost::optional< double > &cy, const boost::optional< double > &xleft, const boost::optional< double > &yleft, const boost::optional< double > &xtop, const boost::optional< double > &ytop)
void | addEllipticalArcTo (unsigned id, unsigned level, const boost::optional< double > &x3, const boost::optional< double > &y3, const boost::optional< double > &x2, const boost::optional< double > &y2, const boost::optional< double > &angle, const boost::optional< double > &ecc)
void | addSplineStart (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y, const boost::optional< double > &secondKnot, const boost::optional< double > &firstKnot, const boost::optional< double > &lastKnot, const boost::optional< unsigned > &degree)
void | addSplineKnot (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y, const boost::optional< double > &knot)
void | addInfiniteLine (unsigned id, unsigned level, const boost::optional< double > &x1, const boost::optional< double > &y1, const boost::optional< double > &x2, const boost::optional< double > &y2)
void | addRelCubBezTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y, const boost::optional< double > &a, const boost::optional< double > &b, const boost::optional< double > &c, const boost::optional< double > &d)
void | addRelEllipticalArcTo (unsigned id, unsigned level, const boost::optional< double > &x3, const boost::optional< double > &y3, const boost::optional< double > &x2, const boost::optional< double > &y2, const boost::optional< double > &angle, const boost::optional< double > &ecc)
void | addRelMoveTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y)
void | addRelLineTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y)
void | addRelQuadBezTo (unsigned id, unsigned level, const boost::optional< double > &x, const boost::optional< double > &y, const boost::optional< double > &a, const boost::optional< double > &b)
void | setElementsOrder (const std::vector< unsigned > &m_elementsOrder)
void | handle (VSDCollector *collector) const
void | clear ()
bool | empty () const
VSDGeometryListElement * | getElement (unsigned index) const
std::vector< unsigned > | getElementsOrder () const
unsigned | count () const
void | resetLevel (unsigned level)

## Private Member Functions
void | clearElement (unsigned id)

## Private Attributes
std::map< unsigned, VSDGeometryListElement * > | m_elements
std::vector< unsigned > | m_elementsOrder

## Constructor & Destructor Documentation

## ◆ VSDGeometryList() [1/2]

libvisio::VSDGeometryList::VSDGeometryList | ( |  | ) |

Referenced by operator=(), and VSDGeometryList().

## ◆ VSDGeometryList() [2/2]

libvisio::VSDGeometryList::VSDGeometryList | ( | const VSDGeometryList & | geomList | ) |

## ◆ ~VSDGeometryList()

libvisio::VSDGeometryList::~VSDGeometryList | ( |  | ) |

## Member Function Documentation

## ◆ addArcTo()

void libvisio::VSDGeometryList::addArcTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x2,
|  | const boost::optional< double > & | y2,
|  | const boost::optional< double > & | bow )

## ◆ addEllipse()

void libvisio::VSDGeometryList::addEllipse | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | cx,
|  | const boost::optional< double > & | cy,
|  | const boost::optional< double > & | xleft,
|  | const boost::optional< double > & | yleft,
|  | const boost::optional< double > & | xtop,
|  | const boost::optional< double > & | ytop )

## ◆ addEllipticalArcTo()

void libvisio::VSDGeometryList::addEllipticalArcTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x3,
|  | const boost::optional< double > & | y3,
|  | const boost::optional< double > & | x2,
|  | const boost::optional< double > & | y2,
|  | const boost::optional< double > & | angle,
|  | const boost::optional< double > & | ecc )

## ◆ addEmpty()

void libvisio::VSDGeometryList::addEmpty | ( | unsigned | id,
|  | unsigned | level )

## ◆ addGeometry()

void libvisio::VSDGeometryList::addGeometry | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< bool > & | noFill,
|  | const boost::optional< bool > & | noLine,
|  | const boost::optional< bool > & | noShow )

## ◆ addInfiniteLine()

void libvisio::VSDGeometryList::addInfiniteLine | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x1,
|  | const boost::optional< double > & | y1,
|  | const boost::optional< double > & | x2,
|  | const boost::optional< double > & | y2 )

## ◆ addLineTo()

void libvisio::VSDGeometryList::addLineTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y )

## ◆ addMoveTo()

void libvisio::VSDGeometryList::addMoveTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y )

## ◆ addNURBSTo() [1/3]

void libvisio::VSDGeometryList::addNURBSTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x2,
|  | const boost::optional< double > & | y2,
|  | const boost::optional< double > & | knot,
|  | const boost::optional< double > & | knotPrev,
|  | const boost::optional< double > & | weight,
|  | const boost::optional< double > & | weightPrev,
|  | const boost::optional< NURBSData > & | data )

## ◆ addNURBSTo() [2/3]

void libvisio::VSDGeometryList::addNURBSTo | ( | unsigned | id,
|  | unsigned | level,
|  | double | x2,
|  | double | y2,
|  | double | knot,
|  | double | knotPrev,
|  | double | weight,
|  | double | weightPrev,
|  | unsigned | dataID )

## ◆ addNURBSTo() [3/3]

void libvisio::VSDGeometryList::addNURBSTo | ( | unsigned | id,
|  | unsigned | level,
|  | double | x2,
|  | double | y2,
|  | unsigned char | xType,
|  | unsigned char | yType,
|  | unsigned | degree,
|  | const std::vector< std::pair< double, double > > & | controlPoints,
|  | const std::vector< double > & | knotVector,
|  | const std::vector< double > & | weights )

## ◆ addPolylineTo() [1/3]

void libvisio::VSDGeometryList::addPolylineTo | ( | unsigned | id,
|  | unsigned | level,
|  | boost::optional< double > & | x,
|  | boost::optional< double > & | y,
|  | boost::optional< PolylineData > & | data )

## ◆ addPolylineTo() [2/3]

void libvisio::VSDGeometryList::addPolylineTo | ( | unsigned | id,
|  | unsigned | level,
|  | double | x,
|  | double | y,
|  | unsigned char | xType,
|  | unsigned char | yType,
|  | const std::vector< std::pair< double, double > > & | points )

## ◆ addPolylineTo() [3/3]

void libvisio::VSDGeometryList::addPolylineTo | ( | unsigned | id,
|  | unsigned | level,
|  | double | x,
|  | double | y,
|  | unsigned | dataID )

## ◆ addRelCubBezTo()

void libvisio::VSDGeometryList::addRelCubBezTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y,
|  | const boost::optional< double > & | a,
|  | const boost::optional< double > & | b,
|  | const boost::optional< double > & | c,
|  | const boost::optional< double > & | d )

## ◆ addRelEllipticalArcTo()

void libvisio::VSDGeometryList::addRelEllipticalArcTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x3,
|  | const boost::optional< double > & | y3,
|  | const boost::optional< double > & | x2,
|  | const boost::optional< double > & | y2,
|  | const boost::optional< double > & | angle,
|  | const boost::optional< double > & | ecc )

## ◆ addRelLineTo()

void libvisio::VSDGeometryList::addRelLineTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y )

## ◆ addRelMoveTo()

void libvisio::VSDGeometryList::addRelMoveTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y )

## ◆ addRelQuadBezTo()

void libvisio::VSDGeometryList::addRelQuadBezTo | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y,
|  | const boost::optional< double > & | a,
|  | const boost::optional< double > & | b )

## ◆ addSplineKnot()

void libvisio::VSDGeometryList::addSplineKnot | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y,
|  | const boost::optional< double > & | knot )

## ◆ addSplineStart()

void libvisio::VSDGeometryList::addSplineStart | ( | unsigned | id,
|  | unsigned | level,
|  | const boost::optional< double > & | x,
|  | const boost::optional< double > & | y,
|  | const boost::optional< double > & | secondKnot,
|  | const boost::optional< double > & | firstKnot,
|  | const boost::optional< double > & | lastKnot,
|  | const boost::optional< unsigned > & | degree )

## ◆ clear()

void libvisio::VSDGeometryList::clear | ( |  | ) |

Referenced by operator=(), and ~VSDGeometryList().

## ◆ clearElement()

void libvisio::VSDGeometryList::clearElement | ( | unsigned | id | ) |
| private

Referenced by addArcTo(), addEllipse(), addEllipticalArcTo(), addEmpty(), addGeometry(), addInfiniteLine(), addLineTo(), addMoveTo(), addNURBSTo(), addNURBSTo(), addNURBSTo(), addPolylineTo(), addPolylineTo(), addPolylineTo(), addRelCubBezTo(), addRelEllipticalArcTo(), addRelLineTo(), addRelMoveTo(), addRelQuadBezTo(), addSplineKnot(), and addSplineStart().

## ◆ count()

unsigned libvisio::VSDGeometryList::count | ( |  | ) | const
| inline

## ◆ empty()

bool libvisio::VSDGeometryList::empty | ( |  | ) | const
| inline

Referenced by handle().

## ◆ getElement()

libvisio::VSDGeometryListElement * libvisio::VSDGeometryList::getElement | ( | unsigned | index | ) | const

## ◆ getElementsOrder()

std::vector< unsigned > libvisio::VSDGeometryList::getElementsOrder | ( |  | ) | const
| inline

## ◆ handle()

void libvisio::VSDGeometryList::handle | ( | VSDCollector * | collector | ) | const

## ◆ operator=()

libvisio::VSDGeometryList & libvisio::VSDGeometryList::operator= | ( | const VSDGeometryList & | geomList | ) |

## ◆ resetLevel()

void libvisio::VSDGeometryList::resetLevel | ( | unsigned | level | ) |

## ◆ setElementsOrder()

void libvisio::VSDGeometryList::setElementsOrder | ( | const std::vector< unsigned > & | m_elementsOrder | ) |

## Member Data Documentation

## ◆ m_elements

std::map<unsigned, VSDGeometryListElement *> libvisio::VSDGeometryList::m_elements
| private

Referenced by addArcTo(), addEllipse(), addEllipticalArcTo(), addEmpty(), addGeometry(), addInfiniteLine(), addLineTo(), addMoveTo(), addNURBSTo(), addNURBSTo(), addNURBSTo(), addPolylineTo(), addPolylineTo(), addPolylineTo(), addRelCubBezTo(), addRelEllipticalArcTo(), addRelLineTo(), addRelMoveTo(), addRelQuadBezTo(), addSplineKnot(), addSplineStart(), clear(), clearElement(), count(), empty(), getElement(), handle(), operator=(), resetLevel(), VSDGeometryList(), and VSDGeometryList().

## ◆ m_elementsOrder

std::vector<unsigned> libvisio::VSDGeometryList::m_elementsOrder
| private

Referenced by clear(), getElement(), getElementsOrder(), handle(), operator=(), setElementsOrder(), VSDGeometryList(), and VSDGeometryList().

The documentation for this class was generated from the following files:

- VSDGeometryList.h
- VSDGeometryList.cpp